/*
 * Copyright (c) 2007, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.wso2.registry;

import java.util.Date;
import java.util.Properties;
import java.util.List;
import java.io.InputStream;

public interface Resource {
    String getAuthorUserName();

    Date getCreatedTime();

    Date getLastModified();

    String getDescription();

    void setDescription(String description);

    String getPath();

    String getMediaType();

    int getState();

    void setMediaType(String mediaType);

    String getParentPath();

    String getProperty(String key);

    public List getPropertyValues(String key);

    Properties getProperties();

    void setProperty(String key, String value);

    void addProperty(String key, String value);

    void setProperties(Properties properties);

    Object getContent() throws RegistryException;

    void setContent(Object content);

    String getLastUpdaterUserName();

    String[] getDependents();

    void setDependents(String[] dependents);

    void addDependent(String dependentPath);

    String[] getDependencies();

    void setDependencies(String[] dependencies);

    void addDependency(String dependencyPath);

    InputStream getContentStream() throws RegistryException;

    void setContentStream(InputStream contentStream);
}
